package com.sh.share.req;

import com.sh.share.utils.MyUtils;

import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;

public class ShareUpdateReq {

    private Long shareId;

    private String name;

    @NotNull(message = "【分享内容类型编码】不能为空")
    private String contentTypeCode;

    @NotNull(message = "【分享内容类型id】不能为空")
    private String shareResourceId;

    private String shareResourceImage;

    private Integer shareResourceStatus;

    private Integer version;

    private Long parentVersionId;

    private Date updateTime;

    private String updateBy;

    private Long deptId;

    private Integer groupIndex;

    private Long groupPi;

    private Long tenantId;

    private String summary;

    private String description;

    private Long settingId;

    private String shareBy;

    private String shareName;

    private List<String> sharedToIds;

    private String receiverTypeCode;

    private Date shareTime;

    private Date shareExpireTime;

    private Long sharePermission;

    private Boolean encryptedShare;

    private Integer time;


    public Long getShareId() {
        return shareId;
    }

    public void setShareId(Long shareId) {
        this.shareId = shareId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getContentTypeCode() {
        return contentTypeCode;
    }

    public void setContentTypeCode(String contentTypeCode) {
        this.contentTypeCode = contentTypeCode;
    }

    public String getShareResourceId() {
        return shareResourceId;
    }

    public void setShareResourceId(String shareResourceId) {
        this.shareResourceId = shareResourceId;
    }

    public String getShareResourceImage() {
        return shareResourceImage;
    }

    public void setShareResourceImage(String shareResourceImage) {
        this.shareResourceImage = shareResourceImage;
    }

    public Integer getShareResourceStatus() {
        return 0;
    }

    public void setShareResourceStatus(Integer shareResourceStatus) {
        this.shareResourceStatus = shareResourceStatus;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public Long getParentVersionId() {
        return parentVersionId;
    }

    public void setParentVersionId(Long parentVersionId) {
        this.parentVersionId = parentVersionId;
    }

    public Date getUpdateTime() {
        return new Date();
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    public Long getDeptId() {
        return deptId;
    }

    public void setDeptId(Long deptId) {
        this.deptId = deptId;
    }

    public Integer getGroupIndex() {
        return groupIndex;
    }

    public void setGroupIndex(Integer groupIndex) {
        this.groupIndex = groupIndex;
    }

    public Long getGroupPi() {
        return groupPi;
    }

    public void setGroupPi(Long groupPi) {
        this.groupPi = groupPi;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public String getSummary() {
        return summary;
    }

    public void setSummary(String summary) {
        this.summary = summary;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Long getSettingId() {
        return settingId;
    }

    public void setSettingId(Long settingId) {
        this.settingId = settingId;
    }

    public String getShareBy() {
        return shareBy;
    }

    public void setShareBy(String shareBy) {
        this.shareBy = shareBy;
    }

    public String getShareName() {
        return shareName;
    }

    public void setShareName(String shareName) {
        this.shareName = shareName;
    }

    public List<String> getSharedToIds() {
        return sharedToIds;
    }

    public void setSharedToIds(List<String> sharedToIds) {
        this.sharedToIds = sharedToIds;
    }

    public String getReceiverTypeCode() {
        return receiverTypeCode;
    }

    public void setReceiverTypeCode(String receiverTypeCode) {
        this.receiverTypeCode = receiverTypeCode;
    }

    public Date getShareExpireTime() {
        Date updateTime1 = getUpdateTime();
        return MyUtils.addDate(updateTime1, getTime());
    }

    public void setShareExpireTime(Date shareExpireTime) {
        this.shareExpireTime = shareExpireTime;
    }

    public Long getSharePermission() {
//        TODO:优化方案，从数据库中获取该类型的位权限总合，而非写死
        return 31L;
    }

    public void setSharePermission(Long sharePermission) {
        this.sharePermission = sharePermission;
    }

    public Boolean getEncryptedShare() {
        return encryptedShare;
    }

    public void setEncryptedShare(Boolean encryptedShare) {
        this.encryptedShare = encryptedShare;
    }

    public Integer getTime() {
        return time;
    }

    public void setTime(Integer time) {
        this.time = time;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", shareId=").append(shareId);
        sb.append(", name=").append(name);
        sb.append(", contentTypeCode=").append(contentTypeCode);
        sb.append(", shareResourceId=").append(shareResourceId);
        sb.append(", shareResourceImage=").append(shareResourceImage);
        sb.append(", shareResourceStatus=").append(shareResourceStatus);
        sb.append(", version=").append(version);
        sb.append(", parentVersionId=").append(parentVersionId);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", updateBy=").append(updateBy);
        sb.append(", deptId=").append(deptId);
        sb.append(", groupIndex=").append(groupIndex);
        sb.append(", groupPi=").append(groupPi);
        sb.append(", tenantId=").append(tenantId);
        sb.append(", summary=").append(summary);
        sb.append(", description=").append(description);
        sb.append(", settingId=").append(settingId);
        sb.append(", shareBy=").append(shareBy);
        sb.append(", shareName=").append(shareName);
        sb.append(", shareToIds=").append(sharedToIds);
        sb.append(", receiverTypeCode=").append(receiverTypeCode);
        sb.append(", shareTime=").append(shareTime);
        sb.append(", shareExpireTime=").append(shareExpireTime);
        sb.append(", sharePermission=").append(sharePermission);
        sb.append(", encryptedShare=").append(encryptedShare);
        sb.append(", time=").append(time);
        sb.append("]");
        return sb.toString();
    }
}