package com.sh.share.service;

import com.sh.share.entity.ShareType;
import com.sh.share.entity.ShareTypePermission;
import com.sh.share.req.AddSharePermissionReq;
import com.sh.share.req.AddShareTypeReq;

import java.util.List;

/**
 * @author xiaozun
 * @since 2024/05/08/11:39
 */
public interface ShareInfoService {

    /**
     * 删除分享类型（逻辑删除）
     *
     * @param typeCode 分享类型编码
     */
    void fakeDelType(String typeCode);

    /**
     *删除权限类型（逻辑删除）
     *
     * @param permissionCode 分享权限编码
     * */
    void fakeDelPermission(String permissionCode);

    /**
     * 获取所有分享类型
     *
     * @return List<ShareType>
     * */
    List<ShareType> getAllShareType();

    /**
     * 获取分享类型对象
     *
     * @param typeCode 分享类型编号
     * */
    ShareType getShareType(String typeCode);

    /**
     * 生成位权限
     * */
    Long addBitPermission(String typeCode);

    /**
     * 获取该分享类型下所有权限对象
     * */
    List<ShareTypePermission> getAllShareTypePermissionByTypeCode(String typeCode);

    /**
     * 新增分享类型
     *
     * @param addShareTypeReq 新增权限信息对象
     * */
    void addShareType(AddShareTypeReq addShareTypeReq);

    /**
     * 新增权限类型
     * */
    void addPermission(AddSharePermissionReq addSharePermissionReq);

}
