package com.sh.share.test;

import com.sh.share.entity.ShareType;
import com.sh.share.req.AddSharePermissionReq;
import com.sh.share.req.AddShareTypeReq;
import com.sh.share.req.HistoryAddReq;
import com.sh.share.req.ShareCreateReq;
import com.sh.share.resp.ShareResp;
import com.sh.share.service.ShareInfoService;
import com.sh.share.service.ShareService;
import com.sh.share.utils.MyUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.util.List;

@SpringBootTest
@RunWith(SpringRunner.class)
public class ShareApplicationTests {

    @Resource
    ShareService shareService;

    @Resource
    ShareInfoService infoService;

    @Test
    public void createShare(){
        ShareCreateReq shareCreateReq = new ShareCreateReq();
        shareCreateReq.setName("豆汁儿实验");
        shareCreateReq.setContentTypeCode("EXPERIMENT");
        shareCreateReq.setCreateBy("xiaozun");
        shareService.createShare(shareCreateReq);
    }

    @Test
    public void getAllShareType(){
        List<ShareType> list = infoService.getAllShareType();
        System.out.println(list);
    }

    @Test
    public void deleteShare(){
        HistoryAddReq historyAddReq = new HistoryAddReq();
        historyAddReq.setId(25L);
        historyAddReq.setOperatorUsername("xiaozun");
        shareService.deleteShare(historyAddReq);
    }

    @Test
    public void overDue(){
        shareService.overDue();
    }

    @Test
    public void addDue(){
        shareService.addDue(27L,8);
    }

    @Test
    public void getShareList(){
        List<ShareResp> sharesList = shareService.getSharesList();
        for (ShareResp shareResp : sharesList) {
            System.out.println(shareResp);
        }
    }

    @Test
    public void getShareById(){
        System.out.println(shareService.getShareById(18L));
    }

    @Test
    public void getLink(){
        System.out.println(shareService.getShareLink(14L));
    }

    @Test
    public void getPwd(){
        System.out.println(shareService.getPassWordBySettingId(18L));
    }

    @Test
    public void test1(){
//        System.out.println(MyUtils.getPermissionCode(ReceiverTypeCodeEnum.USER.toString()));
    }

    @Test
    public void test2(){
/*        List list = MyUtils.getPermissionCode(ReceiverTypeCodeEnum.USER.toString());
        System.out.println(MyUtils.sumBitPermission(list));*/
    }

    @Test
    public void delType(){
        infoService.fakeDelType("FILE");
    }

    @Test
    public void delPermission(){
        infoService.fakeDelPermission("File_View");
    }

    @Test
    public void addShareType(){
        AddShareTypeReq addShareTypeReq = new AddShareTypeReq();
        addShareTypeReq.setName("实体");
        addShareTypeReq.setCode("ENTITY");
        addShareTypeReq.setCreateBy("xiaozun");
        infoService.addShareType(addShareTypeReq);
    }

    @Test
    public void getTypePermissions(){
        System.out.println(infoService.getAllShareTypePermissionByTypeCode("FILE"));
    }

    @Test
    public void test3(){
        System.out.println(infoService.addBitPermission("File"));
    }

    @Test
    public void addPermission(){
        AddSharePermissionReq addSharePermissionReq = new AddSharePermissionReq();
        addSharePermissionReq.setShareTypeCode("ENTITY");
        String typeCode = addSharePermissionReq.getShareTypeCode();
        ShareType shareType = infoService.getShareType(typeCode);
        addSharePermissionReq.setShareTypeId(shareType.getId().toString());
        addSharePermissionReq.setBitPermission(infoService.addBitPermission(typeCode));
        addSharePermissionReq.setPermissionCn("查看");
        addSharePermissionReq.setPermissionEn("Entity_View");
        addSharePermissionReq.setDescription("实体查看权限");
        addSharePermissionReq.setCreateBy("xiaozun");
        infoService.addPermission(addSharePermissionReq);
    }
}
